//别动我代码： list mixin
module.exports = {
  onShow() {
    // console.log('list mixin show');
  },
  onReady() {},
  onReachBottom() {
    this.loadData();
  },
  data() {
    return {
      total: 0,
      listData: [],
      loadmoreStatus: 'loadmore', // loadmore loading nomore
      page: {
        page: 1,
        size: 10,
      },
      queryData: {},
    };
  },
  methods: {
    // 分页初始化数据isUp是否为上拉加载，默认false
    initDataList(searchData = {}, isUp = false) {
      this.isListLoading = true;
      uni.showLoading({
        title: '加载中',
        mask: true,
      });
      this.queryData = searchData;
      if (!isUp) this.page.page = 1;
      this.listApiName({
        search: searchData,
        page: this.page,
      })
        .then(res => {
          if (isUp) {
            this.listData = this.listData.concat(res.data);
          } else {
            this.listData = res.data;
            // this.loadmoreStatus = 'nomore'
          }
          this.total = res.page.total;

          if (this.listData.length < this.total) {
            this.loadmoreStatus = 'loadmore';
          } else {
            this.loadmoreStatus = 'nomore';
          }
        })
        .catch(err => {
          throw err;
        })
        .finally(() => {
          this.isListLoading = false;
          setTimeout(() => {
            uni.hideLoading();
          }, 1000);
        });
    },
    //加载列表，上滑加载
    loadData() {
      this.loadmoreStatus = 'loading';
      if (this.listData.length < this.total) {
        this.page.page++;
        this.initDataList(this.queryData, true);
      } else {
        this.page.page = 1;
        this.loadmoreStatus = 'nomore';
      }
    },
    getListData(apiName, reqData, isLoadmore = false, isSearch = false) {
      uni.y.showLoading('加载中');
      this.loadmoreStatus = 'loading'; // 加载中
      this[apiName](reqData)
        .then(res => {
          const listData = res.data || {};
          const listTotal = res.page.total || 0;
          if (isLoadmore) {
            this.listData = this.listData.concat(listData);
          } else {
            this.listData = listData;
          }
          this.listTotal = listTotal;
          if (this.listData.length === listTotal) {
            this.loadmoreStatus = 'nomore';
          } else {
            this.loadmoreStatus = 'loadmore';
          }
          uni.hideLoading(1000);
        })
        .catch(() => {
          uni.hideLoading(2000);
        });
    },
  },
};
